#
#  tcltkextlib.rb
#
#    shared library ȤʤäƤ Tcl/Tk γĥ饤֥Ѥ뤿
#    tcltklib 饤֥ wrapper 饤֥ꡥ
#    require 'tcltklib' ˤΥ饤֥ require С
#    ¾ʬѹä뤳ȤʤǽĥǤ롥( ΤĤꡥ(^_^; )
#    㤨СTclTkIp.new ȤҤϤΤޤޤǡTclTkExtIp 饹
#    󥹥󥹤롥
#    kind_of?(TclTkIp) ФƤ true ֤
#    type ФƤ TclTkExtIp ֤
#
$TclTkExtLib_Version = '0.4'
#                    2000/09/28  Hidetosh NAGAI (nagai@ai.kyutech.ac.jp)
#

######################################
# 饤֥׵
######################################
# tcltklib ǻ
require 'tcltklib'

######################################
# TclTkIp εǽԤǤ褦ˡ
# TclTkIp  new ֤
######################################
class << TclTkIp
  alias new_orig new
  def new (*args)
    TclTkExtIp.new(*args)
  end
end

######################################
# TclTkExtIp 饹
######################################
class TclTkExtIp
  # TclTkIp 饹֤ȤƵǽ뤿ᡤ
  # Ʊ饹ĥ᥽å _invoke , _eval , _return_value , mainloop 
  # 롥
  def _invoke (*arg)
    @ip._invoke(*arg)
  end

  def _eval (*arg)
    @ip._eval(*arg)
  end

  def _return_value (*arg)
    @ip._return_value(*arg)
  end

  def mainloop (*arg)
    @ip.mainloop (*arg)
  end

  # Tcl/Tk 󥿡ץ꥿Ǥɾ
  # 顼㳰ȯ롥
  def invoke (*arg)
    res = _invoke(*arg)
    fail RuntimeError, res, caller(1) if _return_value != 0
    res
  end

  def eval (*arg)
    res = _eval(*arg)
    fail RuntimeError, res, caller(1) if _return_value != 0
    res
  end

  # Tcl/Tk 󥿡ץ꥿ξõ
  # ºݤˤ root widget '.' ˲򤷤˻Ȥ򳰤ƤǤ롥
  # ξõ Garbage Collect Ǥ
  def delete
    eval('destroy .')
    @ip = nil
  end

  # եΥץȤ load 
  def _load_script_file (file)
    eval("source #{file}")
  end
  private :_load_script_file

  # ǥ쥯ȥ auto_path ɲä
  def _append_path_to_auto_path (dir)
    eval("lappend auto_path #{dir}")
  end
  private :_append_path_to_auto_path

  #  tclIndex ե auto_index Ƥ륳ޥɤΰ
  def _auto_cmd_list_in_tclIndex (libidx)
    # ե򥪡ץ
    fd = open(libidx, 'r')
    begin
      # auto_index ԤǤʤ̵
      #   tclIndex  auto_mkindex Ǻ줿ΤȲꤷ
      #   1 Ԥˤ 1 Ĥ auto_index ꤷʤΤȤ롥
      fd.collect{|line|
	(line =~ /set\s+auto_index\s*\(([^)]+)\)/)? $1: nil 
      }.compact
    ensure
      fd.close
    end
  end
  private :_auto_cmd_list_in_tclIndex

  # ǥ쥯ȥ auto_load ǽޥɤΤ٤Ƥ򿿤 load 
  def _realload_all_cmds_in_libdir (dir, verbose = false)
    # tclIndex Υեѥ
    libidx = File.join(dir,'tclIndex')

    # tclIndex եϿ줿ޥɥꥹȤ
    # ( tclIndex ¸ߤʤ or ɤʤΤǤ̵ )
    cmd_list = (test ?r, libidx)? _auto_cmd_list_in_tclIndex(libidx): []

    # ƥޥɤ auto_load 
    cmd_list.each{|cmd| 
      next if eval("info commands #{cmd}") != '' # ϿѤʤά
      begin
	eval("auto_load #{cmd}")
      rescue RuntimeError
	if verbose
	  STDERR.print "Warning: fail to auto_load `#{cmd}' (ignore)\n"
	end
	# auto_load μԤϡΥ٥Ǥɤˤ褦ȤƤ̵ʤΤ
	# ̵뤹ΤȤ롥
      end
    }

    # ޥɥꥹȤ֤
    cmd_list
  end
  private :_realload_all_cmds_in_libdir

  # auto_path ˤ auto_load ǽʥޥɤ򤹤٤ƿ load 
  def realload_all_auto_load_cmds (verbose = false)
    # auto_path ˤƳ ( ٷڸΤᡤʣϺ )
    path_array = ( eval("set auto_path").split(/\s+/) | [] )

    # γƥ饤֥ѥˤĤƥ饤֥ load
    cmd_list = []
    path_array.each{|path| 
      cmd_list.concat( _realload_all_cmds_in_libdir(path, verbose) )
    }
    cmd_list
  end

  # 饤֥ѥΥץȤѲǽˤ롥
  # ꤬եǤС Tcl/Tk ΥץȤȤ load 롥
  # ꤬ǥ쥯ȥǤС auto_path ɲä롥
  def _load_script_lib (path_array)
    checked = []
    path_array.each{|path|
      path = File.expand_path(path)  # եѥ
      next if checked.include?(path) # åѤ( sym-link Υ롼к )
      checked.push(path)             # ѥåѤɲ
      next unless test ?e, path      # ¸ߤʤ̵
      if test ?f, path               # ̾Υե  ɤ߹ ( source )
	_load_script_file(path)
      elsif test ?d, path            # ǥ쥯ȥ  auto_path ɲ
	_append_path_to_auto_path(path)
      elsif test ?l, path            # symbolic-link  󥯤򤿤ɤ
	path = File.readlink(path)
	redo
      end
    }
  end
  private :_load_script_lib

  # ꤵ줿 shared library  load 
  def _load_shared_lib (lib_name, libbin_path, libtcl_path)
    search_path = (libtcl_path)? libtcl_path.dup: []
    libbin = libbin_path
    begin
      eval("load #{libbin} #{lib_name}")
    rescue RuntimeError
      raise if libbin =~ /^\//   ;# '/' ǻϤޤʤեѥΤϤ
      loop {
	raise if search_path == [] ;# ٤饤֥ѥʤ
	libbin = search_path.shift.chomp('/') + '/' + libbin_path
	break if test ?e, libbin
      }
      retry
    end
  end
  private :_load_shared_lib

  # namespace ѥ᥽å ( for Tcl8.0 over )
  def _get_namespace_sub(namespace, parent)
    eval("namespace children #{parent}").split(/\s+/).each{|name|
      namespace << name
      _get_namespace_sub(namespace, name)
    }
  end
  private :_get_namespace_sub

  # namespace  ( for Tcl8.0 over )
  def get_namespace
    namespace = []
    tclversion = eval("info tclversion")
    return [] if (tclversion < '8.0')
    _get_namespace_sub(namespace, '::')
    (namespace | []).sort
  end

  # ꤵ줿 library Ѳǽʾ֤ˤ롥
  # ʣ¤٤ϡ¤ӽ˽롥
  # shared library ϼºݤ load 롥
  # script library ϡ
  #   ѥΥեǤмºݤ load (source) 
  #   ǥ쥯ȥǤФ auto_path ɲä롥
  def setup_libs (*libs)
    libname = nil
    libs.each{|lib|
      next unless lib
      libname = lib[0]
      @libs.push lib
      _load_shared_lib (lib[0], lib[1], lib[2]) if (lib[1] && lib[1] != '')
      _load_script_lib (lib[2]) if (lib[2] && lib[2] != [])
    }
    libname
  end

  #  library Τ٤ ( auto_path Υޥɤޤ )  load 롥
  # ʣ¤٤ϡ¤ӽ˽롥
  #  library  load  auto_path Υޥɤ
  # Ǥ load ѤߤǤȤȲꤷsetup_libs(library,...) μ¹Ԥ
  # auto_path ɲä줿ʬˤĤơޥɤ load Ԥ
  def full_load_libs (*libs)
    old_path = eval("set auto_path").split(/\s+/)
    libname = setup_libs(*libs)
    new_path = eval("set auto_path").split(/\s+/)
    (new_path - old_path).each{|path| _realload_all_cmds_in_libdir(path) }
    libname
  end

  # TclTkIp Υ֥饹ȤƲ᤹褦ˡkind_of? , is_a? 
  def kind_of? (class_name)
    @ip.kind_of?(class_name) || super
  end
  alias is_a? kind_of?

  # ̤ΤΥ᥽åɤ TclTkIp ֥Ȥ˰Ϥ ()
  def method_missing(id, *args)
    @ip.send(id, *args)
  end

  # ᥽å
  # 
  # Ȥơload ĥ饤֥ξǼ᤿¤Ӥꤹ롥
  # ĥ饤֥ϰ¤ӽˡĤɤ߹ޤ롥
  # 
  # 饤֥ϡ[ѥå̾, 饤֥̾, 饤֥ѥ]
  # Ȥ󤫤ʤǻꤹ롥
  # 
  # 饤֥̾ˤϡload ٤ shared library ؤΥѥꤹ롥
  # Υ饤֥꤬ǥեȤ auto_path 夫ޤϡ
  # Υ饤֥ޤǤɲä줿饤֥ѥˤʤС
  # 饤֥̾λǤޤʤǤʤϡ
  # Υ饤֥ؤΥեѥꤹ뤫
  # Υ饤֥꤬ǥ쥯ȥ饤֥ѥ
  # ꤷʤФʤʤ
  # 
  # 饤֥̾ nil ޤ϶ʸΤȤϡ
  # 饤֥ΥХʥʬϤʤäƤȤ߹ߺѤΥ饤֥ȸʤ
  # 
  # 饤֥ѥˤϡγĥ饤֥˴Ϣ
  # ץȥ饤֥ؤΥѥˤޤȤƻꤹ롥
  # ꤵ줿ѥΥեؤƤΤǤС
  # Υե뤬ɤ߹ޤ롥
  #
  # ޥɸκݤϡѥǥ쥯ȥؤƤΤǤС
  # Υǥ쥯ȥˤ tclIndex ե auto_load ˽äơ
  # ٤ƤΥ饤֥ load 롥
  # ʤtclIndex եȤ Tcl  auto_mkindex Ǻ줿Ȳꤷ
  # ԤˤĤ¿Ƥ 1 Ĥ auto_load ꤷ¸ߤʤΤȤƤ롥
  def initialize(*libs)
    @libs = []
    @namespace = []
    @ip = TclTkIp.new_orig
    setup_libs(*libs)
  end
end
######################################
# end of TclTkExtIp class
######################################
